"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _DbmlExporter = _interopRequireDefault(require("./DbmlExporter"));
var _MysqlExporter = _interopRequireDefault(require("./MysqlExporter"));
var _PostgresExporter = _interopRequireDefault(require("./PostgresExporter"));
var _JsonExporter = _interopRequireDefault(require("./JsonExporter"));
var _SqlServerExporter = _interopRequireDefault(require("./SqlServerExporter"));
var _OracleExporter = _interopRequireDefault(require("./OracleExporter"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var ModelExporter = /*#__PURE__*/function () {
  function ModelExporter() {
    _classCallCheck(this, ModelExporter);
  }
  _createClass(ModelExporter, null, [{
    key: "export",
    value: function _export() {
      var model = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      var isNormalized = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var res = '';
      var normalizedModel = isNormalized ? model : model.normalize();
      switch (format) {
        case 'dbml':
          res = _DbmlExporter["default"]["export"](normalizedModel);
          break;
        case 'mysql':
          res = _MysqlExporter["default"]["export"](normalizedModel);
          break;
        case 'postgres':
          res = _PostgresExporter["default"]["export"](normalizedModel);
          break;
        case 'json':
          res = _JsonExporter["default"]["export"](model, isNormalized);
          break;
        case 'mssql':
          res = _SqlServerExporter["default"]["export"](normalizedModel);
          break;
        case 'oracle':
          res = _OracleExporter["default"]["export"](normalizedModel);
          break;
        default:
          break;
      }
      return res;
    }
  }]);
  return ModelExporter;
}();
var _default = ModelExporter;
exports["default"] = _default;